{ Original version 25-Nov-91 }

uses
	Crt,Graph;

type
	Float = {$IFOPT N+} Double {$ELSE} Real {$ENDIF};

const
	Esc = #27;
	Ret = #13;
	Brk = #03;

	MinX = 0;
	MinY = 10;
	MaxX = 319;
	MaxY = 189;

	Left = 94;
	Down = 199;
	MaxN = 200;

	High = 9;
	h1 = 3;
	h2 = 6;

	InternalColor = 0; { Black }
	ExternalColor = 1; { Green }
	BkGroundColor = 2; { Red }
	FrameLinColor = 3; { Yellow }


type
	SaveFrame = record
					x,y,r : Integer;
					p1,p2,p3,p4 : Pointer;
					n1,n2,n3,n4 : Integer;
				end;


var
	f : SaveFrame;
	N : Integer;


procedure LinkCGA; external; {$L CGA.OBJ }
procedure LinkGoth; external; {$L GOTH.OBJ  }


{ Here is C-like procedures/functions pre-definition list }

procedure Prepare; forward;
procedure Compute( xr,yr,rr : Float; xi,yi,ri : Integer ); forward;
procedure Zoom( xr,yr,rr : Float; xi,yi,ri : Integer ); forward;
function  Test( Re0,Im0 : Float ) : Boolean; forward;
procedure Scale( n : Integer ); forward;
procedure UnScale( n : Integer ); forward;
function  ReScale( var n : Integer ) : Boolean; forward;
procedure Frame( var f : SaveFrame ); forward;
procedure UnFrame( var f : SaveFrame ); forward;
function  ReFrame( var f : SaveFrame;
				  x0,y0,x1,y1 : Integer ) : Boolean; forward;
function Complete : Boolean; forward;


procedure Prepare;
	var
		Gd,Gm,Code,i : Integer;
begin

	DirectVideo := False;
	CheckBreak := False;

	Code := RegisterBgiDriver( @LinkCGA );
	Code := RegisterBGIFont( @LinkGoth );
	Gd := CGA; Gm := CGAC0;
	InitGraph( Gd,Gm,'' );

	SetFillStyle( SolidFill,BkGroundColor );
	Bar( MinX,MinY,MaxX,MaxY );

	SetColor( ExternalColor );
	SetUserCharSize( 6,5,3,1 );
	SetTextJustify( CenterText, CenterText );
	SetTextStyle( GothicFont,HorizDir,UserCharSize );
	OutTextXY( (MaxX-MinX) div 2 + MinX, (MaxY-MinY) * 3 div 10 + MinY,
			   'MandelZoom' );
	SetTextStyle( GothicFont,HorizDir,1 );
	OutTextXY( (MaxX-MinX) div 2 + MinX, (MaxY-MinY) * 7 div 10 + MinY,
			   ' By Cyril A. Slobin' );
	SetTextStyle( DefaultFont,HorizDir,1 );

	GotoXY( 1,25 ); Write( 'Iterations 1' );
	GotoXY( 38,25 ); Write( MaxN );
	SetColor( FrameLinColor );
	for i := 0 to MaxN do UnScale( i );

	Randomize;

end; { Prepare }


procedure Compute( xr,yr,rr : Float; xi,yi,ri : Integer );
	var
		xr2,yr2,rr2 : Float;
		p : Pointer;
		size : Integer;
		f1,f2 : SaveFrame;
begin

	size := ImageSize( xi-ri+1,yi-ri+1,xi+ri-1,yi+ri-1 );
	GetMem( p,size );
	GetImage( xi-ri+1,yi-ri+1,xi+ri-1,yi+ri-1,p^ );

	GotoXY( 1,1 );
	Write( 'X=',xr:10:7,'  Y=',yr:10:7,'  R=',rr:10:7 );

	Zoom( xr,yr,rr,xi,yi,ri-1 );

	f1.x := xi; f1.y := yi;
	f1.r := ri div 3 + 2;

	f2.x := MinX + ri + Random( MaxX-MinX-2*ri );
	f2.y := MinY + ri + Random( MaxY-MinY-2*ri );
	f2.r := ri;

	while ReScale( N ) do
	begin
		GotoXY( 1,1 );
		Write( '         Point to SOURCE window         ' );
		Frame( f1 );

		while ReFrame( f1, xi-ri,yi-ri,xi+ri,yi+ri ) do
		begin
			xr2 := xr + ( f1.x - xi ) * ( rr / (ri-1) );
			yr2 := yr + ( f1.y - yi ) * ( rr / (ri-1) );
			rr2 := ( f1.r - 1 ) * ( rr / (ri-1) );

			GotoXY( 1,1 );
			Write( '         Point to TARGET window         ' );
			Frame( f2 );

			while ReFrame( f2, MinX,MinY,MaxX,MaxY ) do
			begin
				Compute( xr2,yr2,rr2, f2.x,f2.y,f2.r );
				GotoXY( 1,1 );
				Write( '         Point to TARGET window         ' );
			end; { while }

			UnFrame( f2 );
			GotoXY( 1,1 );
			Write( '         Point to SOURCE window         ' );
		end; { while }

		UnFrame( f1 );
		GotoXY( 1,1 );
		Write( 'X=',xr:10:7,'  Y=',yr:10:7,'  R=',rr:10:7 );
	end; { while }

	PutImage( xi-ri+1,yi-ri+1,p^,0 );
	FreeMem( p,size );

end; { Compute }


procedure Zoom( xr,yr,rr : Float; xi,yi,ri : Integer );
	var
		i,j : Integer;
begin
	Line( xi-ri,yi-ri,xi+ri,yi-ri );
	for j := -ri to ri do
	begin
		for i := -ri to ri do
		begin
			if KeyPressed then if ReadKey = Brk then Exit;
			PutPixel( xi+i,yi+j+1,FrameLinColor );
			if Test( xr+i*rr/ri,yr+j*rr/ri )
				then PutPixel( xi+i,yi+j,InternalColor )
				else PutPixel( xi+i,yi+j,ExternalColor );
		end; { for }
	end; { for }
end; { Zoom }


function Test( Re0,Im0 : Float ) : Boolean;
	var
		Re,Im,tt : Float;
		k : Byte;
begin
	Re := 0.0; Im := 0.0;
	Test := False;
	for k := 1 to N do
		begin
			tt := Re * Im;
			Re := ( Re-Im ) * ( Re+Im ) + Re0;
			Im := tt + tt + Im0;
			if ( abs(Re) > 2.0 ) or ( abs(Im) > 2.0 ) then Exit;
		end; { for }
	Test := True;
end; { Test }


procedure Scale( n : Integer );
begin
	SetColor( BkGroundColor );
	Line( Left+n,Down,Left+n,Down-High+1 );
	SetColor( FrameLinColor );
end; { Scale }


procedure UnScale( n : Integer );
begin
	SetColor( BLACK );
	Line( Left+n,Down,Left+n,Down-High+1 );
	SetColor( FrameLinColor );
	if N mod 10 = 0	then
		if N mod 50 = 0
			then Line( Left+N,Down,Left+N,Down-h2+1 )
			else Line( Left+N,Down,Left+N,Down-h1+1 );
end; { UnScale }


function ReScale( var n : Integer ) : Boolean;
begin
	while True do
	begin
		case ReadKey of
		  #0 : begin
					UnScale( n );
					case ReadKey of
					  #75 : if N > 1 then Dec(n);
					  #77 : if N < MaxN then Inc(n);
					end; { case }
					Scale( n );
			   end; { begin }
		  Ret : begin ReScale := True; Exit end;
		  Esc : begin ReScale := False; Exit end;
		  Brk : if Complete then begin CloseGraph; Halt end;
		end; { case }
	end; { while }
end; { ReScale }


procedure Frame( var f : SaveFrame );
begin
	with f do
	begin
		n1 := ImageSize(x-r,y-r,x-r,y+r);
		n2 := ImageSize(x+r,y-r,x+r,y+r);
		n3 := ImageSize(x-r,y-r,x+r,y-r);
		n4 := ImageSize(x-r,y+r,x+r,y+r);
		GetMem( p1,n1);
		GetMem( p2,n2);
		GetMem( p3,n3);
		GetMem( p4,n4);
		GetImage( x-r,y-r,x-r,y+r,p1^ );
		GetImage( x+r,y-r,x+r,y+r,p2^ );
		GetImage( x-r,y-r,x+r,y-r,p3^ );
		GetImage( x-r,y+r,x+r,y+r,p4^ );
		Rectangle( x-r,y-r,x+r,y+r );
	end; { with }
end; { Frame }


procedure UnFrame( var f : SaveFrame );
begin
	with f do
	begin
		PutImage( x-r,y-r,p1^,0 );
		PutImage( x+r,y-r,p2^,0 );
		PutImage( x-r,y-r,p3^,0 );
		PutImage( x-r,y+r,p4^,0 );
		FreeMem( p1,n1 );
		FreeMem( p2,n2 );
		FreeMem( p3,n3 );
		FreeMem( p4,n4 );
	end; { with }
end; { UnFrame }


function ReFrame( var f : SaveFrame;
				x0,y0,x1,y1 : Integer ) : Boolean;
begin
	with f do
	begin
		while True do
		begin
			repeat until KeyPressed;
			UnFrame( f );
			case ReadKey of
			  #0  : case ReadKey of
						#71 : if (x-r > x0) and (y-r > y0)
								then begin Dec(x); Dec(y); end;
						#72 : if y-r > y0
								then Dec(y);
						#73 : if (x+r < x1) and (y-r > y0)
								then begin Inc(x); Dec(y); end;
						#75 : if x-r > x0
								then Dec(x);
						#77 : if x+r < x1
								then Inc(x);
						#79 : if (x-r > x0) and (y+r < y1)
								then begin Dec(x); Inc(y); end;
						#80 : if y+r < y1
								then Inc(y);
						#81 : if (x+r < x1) and (y+r < y1)
								then begin Inc(x); Inc(y); end;
				end; { case }
			  '+' : if (y-r>y0) and (x-r>x0) and (x+r<x1) and (y+r<y1)
					  then Inc(r);
			  '-' : if r > 2 then Dec(r);
			  Ret : begin Frame( f ); ReFrame := True; Exit end;
			  Esc : begin Frame( f ); ReFrame := False; Exit end;
			  Brk : if Complete then begin CloseGraph; Halt end;
			end; { case }
			Frame( f );
		end; { while }
	end; { with }
end; { ReFrame }


function Complete : Boolean;
	const
		Ask = 'Exit to DOS? [Y/N]';
	var
		dw,dh,x0,y0,x1,y1,n : Integer;
		p : Pointer; b : Boolean;
begin
	dw := ( MaxX - MinX - TextWidth(Ask) - 20 ) div 2;
	dh := ( MaxY - MinY - TextHeight(Ask) - 16 ) div 2;
	x0 := MinX + dw; x1 := MaxX - dw;
	y0 := MinY + dh; y1 := MaxY - dh;
	n := ImageSize(x0,y0,x1,y1);
	GetMem( p,n );
	GetImage( x0,y0,x1,y1,p^ );
	Bar( x0,y0,x1,y1 );
	Rectangle( x0+4,y0+4,x1-4,y1-4 );
	OutTextXY( ( MaxX + MinX ) div 2, ( MaxY + MinY ) div 2, Ask );
	b := True;
	while b do
	begin
		case ReadKey of
		  'y','Y' : begin Complete := True; b := False; end;
		  'n','N' : begin Complete := False; b := False; end;
		end; { case }
	end; { while }
	PutImage( x0,y0,p^,0 );
	FreeMem( p,n );
end; { Complete }

begin
	Prepare;
	repeat
		N := 15;
		Scale( N );
		f.x := 30; f.y := 30 + MinY; f.r := 30;
		Frame( f );
		Compute( -0.7,0.0,1.5, 30,40,30 );
		Unframe( f );
		UnScale( n );
	until Complete;
	CloseGraph;
end.
